---
policy: /ce/ca/azure/cosmos-db/virtual-network-filter
logic: /ce/ca/azure/cosmos-db/virtual-network-filter/prod.logic.yaml
executionTime: 2025-04-24T23:45:21.13182782Z
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__virtualNetworkFilterState__c') == 'Disabled'
      actual: extract('CA10__virtualNetworkFilterState__c') == 'Disabled'
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: extract('CA10__virtualNetworkFilterState__c') == 'Enabled'
      actual: extract('CA10__virtualNetworkFilterState__c') == 'Enabled'
    runtimeError: {}
  - id: test4
    match: true
    status:
      expected: UNDETERMINED
      actual: UNDETERMINED
    conditionIndex:
      expected: 101
      actual: 101
    conditionText:
      expected: CA10__virtualNetworkFilterState__c.isEmpty()
      actual: CA10__virtualNetworkFilterState__c.isEmpty()
    runtimeError: {}
usedFiles:
  - path: /ce/ca/azure/cosmos-db/virtual-network-filter/policy.yaml
    md5Hash: 463818D095B7EAD0C6CB1019F1821206
    content: |
      ---
      names:
        full: Azure Cosmos DB Account Virtual Network Filter is not enabled
        contextual: Virtual Network Filter is not enabled
      description: Limiting your Cosmos DB to only communicate on whitelisted networks lowers
        its attack footprint.
      type: COMPLIANCE_POLICY
      categories:
        - SECURITY
      frameworkMappings:
        - "/frameworks/cis-azure-v2.1.0/04/05/01"
        - "/frameworks/cis-azure-v3.0.0/05/04/01"
        - "/frameworks/cloudaware/resource-security/public-and-anonymous-access"
      similarPolicies:
        internal:
          - dec-x-46a83a30
        cloudConformity:
          - url: https://www.trendmicro.com/cloudoneconformity/knowledge-base/azure/CosmosDB/restrict-default-network-access.html
            name: Restrict Default Network Access for Azure Cosmos DB Accounts
  - path: /ce/ca/azure/cosmos-db/virtual-network-filter/prod.logic.yaml
    md5Hash: 8D3819475054CBA024F4BFA4C91771CC
    content: |-
      ---
      inputType: "CA10__CaAzureCosmosDbAccount__c"
      testData:
        - file: "test-data.json"
      importExtracts:
        - file: "/types/CA10__CaAzureCosmosDbAccount__c/object.extracts.yaml"
      conditions:
        - status: "INCOMPLIANT"
          currentStateMessage: "Cosmos DB Account Virtual Network Filter is disabled."
          remediationMessage: "Consider enabling Cosmos DB Account Virtual Network Filter."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__virtualNetworkFilterState__c"
              right:
                TEXT: "Disabled"
        - status: "COMPLIANT"
          currentStateMessage: "Cosmos DB Account Virtual Network Filter is enabled."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__virtualNetworkFilterState__c"
              right:
                TEXT: "Enabled"
      otherwise:
        status: "UNDETERMINED"
        currentStateMessage: "Unexpected value in the field."
  - path: /ce/ca/azure/cosmos-db/virtual-network-filter/test-data.json
    md5Hash: A7A9CE8165B1E3B833000626679B6D37
    content: |-
      [
          {
              "expectedResult": {
                  "status": "DISAPPEARED",
                  "conditionIndex": "99",
                  "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-13T04:17:29Z"
              },
              "Id": "test1",
              "CA10__disappearanceTime__c": "2024-06-07T13:58:24Z",
              "CA10__virtualNetworkFilterState__c": "Enabled"
          },
          {
              "expectedResult": {
                  "status": "INCOMPLIANT",
                  "conditionIndex": "199",
                  "conditionText": "extract('CA10__virtualNetworkFilterState__c') == 'Disabled'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-13T04:17:29Z"
              },
              "Id": "test2",
              "CA10__disappearanceTime__c": null,
              "CA10__virtualNetworkFilterState__c": "Disabled"
          },
          {
              "expectedResult": {
                  "status": "COMPLIANT",
                  "conditionIndex": "299",
                  "conditionText": "extract('CA10__virtualNetworkFilterState__c') == 'Enabled'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-13T04:17:29Z"
              },
              "Id": "test3",
              "CA10__disappearanceTime__c": null,
              "CA10__virtualNetworkFilterState__c": "Enabled"
          },
          {
              "expectedResult": {
                  "status": "UNDETERMINED",
                  "conditionIndex": "101",
                  "conditionText": "CA10__virtualNetworkFilterState__c.isEmpty()",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-06-13T04:17:29Z"
              },
              "Id": "test4",
              "CA10__disappearanceTime__c": null,
              "CA10__virtualNetworkFilterState__c": ""
          }
      ]
  - path: /types/CA10__CaAzureCosmosDbAccount__c/object.extracts.yaml
    md5Hash: 8D1428F8531B11CD3940369844DFAE3D
    content: "---\nextracts:\n# Values: Enabled, Disabled. Not Nullable. Can't have\
      \ no access, retrieved via Microsoft.DocumentDB/databaseAccounts\n  - name:\
      \ \"CA10__virtualNetworkFilterState__c\"\n    value: \n      FIELD:\n      \
      \  path: \"CA10__virtualNetworkFilterState__c\"\n        undeterminedIf:\n \
      \         isEmpty: \"Corrupted Data. Cosmos DB Account Virtual Network Filter\
      \ cannot be empty.\"\n"
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10__virtualNetworkFilterState__c') == 'Disabled'",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "extract('CA10__virtualNetworkFilterState__c') == 'Enabled'",
      "runtimeError" : null
    }
  }, {
    "Id" : "test4",
    "expectedResult" : {
      "status" : "UNDETERMINED",
      "conditionIndex" : "101",
      "conditionText" : "CA10__virtualNetworkFilterState__c.isEmpty()",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAzureCosmosDbAccount__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__virtualNetworkFilterState__c STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2024-06-13T04:17:29Z")
    },
    "Id" : "test1",
    "CA10__disappearanceTime__c" : new Date("2024-06-07T13:58:24Z"),
    "CA10__virtualNetworkFilterState__c" : "Enabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-13T04:17:29Z")
    },
    "Id" : "test2",
    "CA10__virtualNetworkFilterState__c" : "Disabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-13T04:17:29Z")
    },
    "Id" : "test3",
    "CA10__virtualNetworkFilterState__c" : "Enabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-06-13T04:17:29Z")
    },
    "Id" : "test4",
    "CA10__virtualNetworkFilterState__c" : ""
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAzureCosmosDbAccount__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__virtualNetworkFilterState__c STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TextLib = new function () {
          this.normalize = function(arg) {
              return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
          };
          this.isEmpty = function(arg) {
              return this.normalize(arg) == '';
          };
          this.isNotEmpty = function(arg) {
              return this.normalize(arg) != '';
          };
          this.equal = function(left, right) {
              return this.normalize(left) == this.normalize(right);
          };
          this.notEqual = function(left, right) {
              return this.normalize(left) != this.normalize(right);
          };
          this.startsWith = function(arg, substring) {
              return this.normalize(arg).startsWith(this.normalize(substring));
          };
          this.endsWith = function(arg, substring) {
              return this.normalize(arg).endsWith(this.normalize(substring));
          };
          this.contains = function(arg, substring) {
              return this.normalize(arg).includes(this.normalize(substring));
          };
      }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From Azure [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function fieldChecked4() {
          if (TextLib.isEmpty(obj.CA10__virtualNetworkFilterState__c)) {
              throw new Error("UNDETERMINED condition:101", {cause: {status: 'UNDETERMINED', conditionIndex: 101, conditionText: "CA10__virtualNetworkFilterState__c.isEmpty()", currentStateMessage: "Corrupted Data. Cosmos DB Account Virtual Network Filter cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__virtualNetworkFilterState__c;
      }
      function extract3() { if (!this.out) { this.out = fieldChecked4(); } return this.out; };
      references1.push('Virtual Network Filter State [obj.CA10__virtualNetworkFilterState__c]: ' + obj.CA10__virtualNetworkFilterState__c);
      try {
          if (TextLib.equal(extract3.call(extract3), 'Disabled')) {
              return {status: 'INCOMPLIANT', conditionIndex: 199, conditionText: "extract('CA10__virtualNetworkFilterState__c') == 'Disabled'", currentStateMessage: "Cosmos DB Account Virtual Network Filter is disabled.", currentStateReferences: references1.join('\n'), remediation: "Consider enabling Cosmos DB Account Virtual Network Filter.", runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[2], conditionIndex:[200..299]
      function fieldChecked7() {
          if (TextLib.isEmpty(obj.CA10__virtualNetworkFilterState__c)) {
              throw new Error("UNDETERMINED condition:201", {cause: {status: 'UNDETERMINED', conditionIndex: 201, conditionText: "CA10__virtualNetworkFilterState__c.isEmpty()", currentStateMessage: "Corrupted Data. Cosmos DB Account Virtual Network Filter cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__virtualNetworkFilterState__c;
      }
      function extract6() { if (!this.out) { this.out = fieldChecked7(); } return this.out; };
      try {
          if (TextLib.equal(extract6.call(extract6), 'Enabled')) {
              return {status: 'COMPLIANT', conditionIndex: 299, conditionText: "extract('CA10__virtualNetworkFilterState__c') == 'Enabled'", currentStateMessage: "Cosmos DB Account Virtual Network Filter is enabled.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      return {status: 'UNDETERMINED', conditionIndex: 300, conditionText: "otherwise", currentStateMessage: "Unexpected value in the field.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__virtualNetworkFilterState__c AS CA10__virtualNetworkFilterState__c,
          process_CA10__CaAzureCosmosDbAccount__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__virtualNetworkFilterState__c AS CA10__virtualNetworkFilterState__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAzureCosmosDbAccount__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
